// Class code set03
// Demonstrates the use of pushMatrix( ) and popMatrix( ) in 3-D space.
// Demonstrates the method box( ) and sphere( ).


// IF YOU ARE INTERESTED, the image in the window can be rotated by removing the comment marks 
// on the function calls for the rotate functions.


// Fill uses hexadecimal values instead of rgb.  The hex values 
// are available in the Color Selector Tool.  
// The # in the argument list tells Processing that the value is a hex value.

// The functions pushMatrix( ) and popMatrix( ) are .  They allow us
// to translate from (0, 0, 0) to some place, draw stuff, and jump back to (0, 0, 0).
// Most novices think that it is easier to calculate translations from a single fixed place like 
// the upper left corner.  
// The function pushMatrix( ) gives us a copy of the information (the matrix) that Processing 
// needs to draw the figures in proper perspective.  Any drawring we do after calling pushMatrix( )
// is done by Processing using this copy. The original matrix is not altered.
// When we call the function popMatrix( ), the altered copy is discarded and Processing will use the
// oringinal matrix for future drawing.

// Yhis sets screen size and init variables width and height
// and put Processing into 3-D mode.
size( 600, 600, P3D );



// declare any variables needed herevariables
   // The following variables are assigned values here so only one
   // edit is needed to change their values.  
float radius = .04*width;
float edge = .12*width;

background( 0 );
//background( #04075A );  // This is a hexadecimal number provided by the Color Selector tool.
lights( );  // Run this with the lights turned on and then comment this out with two // 
            // to turn out the lights and run it again.


// You can ignore the following comments and code.
// This for those of you who want to fool around with rotations.
// Remember -- translate first, then rotate.
// The function popMatrix cancels the rotation.

// The rotate methods require arguments in terms of radians to work properly.
// The radians( ) method takes a degree amount for an argument and returns
// a corresponding radian value that is used for the rotation argument.

// The following lines of code may appear confusing.  
   // The reason two translates are used instead of a pushMatrix/popMatrix pair is that
   // they would cancel the rotation.
translate( width/2, height/2, 0 );  // move (0,0,0 to the center of the window 
  //rotateY( radians( 45 ) );
  //rotateX( radians( 33 ) );
  //rotateZ( radians( 20 ) );
translate( -width/2, -height/2, 0 );  // nove (0,0,0) back to the upper left corner

noStroke( );
// center sphere
pushMatrix( );
  translate( width*.5, height*.5, 0 );
  fill( #F79007 );
  sphere( radius);
popMatrix( );


stroke( 255 );
strokeWeight( 2 );
// box behind center sphere
pushMatrix( );
 translate ( width*.5, height*.5, - 50 );  // -50 is a magic number which could be bad
 fill( #0CEA41 );
 box( edge);
popMatrix( );


// box in front of center sphere
pushMatrix( );
 translate ( width*.5, height*.5,  50 );  // 50 is also a magic number
 fill( #EA0C44 );
 box( edge/5);
popMatrix( );

// box above center sphere
pushMatrix( );
 translate ( width*.5, height*.3, 0  );
 fill( #F4F507 );
 box( 2*edge, .5*edge, edge);
popMatrix( );

// box below center sphere
pushMatrix( );
 translate ( width*.5, height*.7, 0  );
 fill( #F507DA );
 box( edge);
popMatrix( );

// box left of the center sphere
pushMatrix( );
 translate ( width*.3, height*.5, 0  );
 fill( #07F5DF );
 box( edge, 4*edge, .1*edge);
popMatrix( );

// box right of the center sphere
pushMatrix( );
 translate ( width*.7, height*.5, 0  );
 fill( #0E4AEA );
 box( .1*edge, 4*edge, edge);
popMatrix( );


